// Code generated by SQLBoiler (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package postgres

import (
	"bytes"
	"context"
	"reflect"
	"testing"

	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/randomize"
	"github.com/volatiletech/sqlboiler/strmangle"
)

var (
	// Relationships sometimes use the reflection helper queries.Equal/queries.Assign
	// so force a package dependency in case they don't.
	_ = queries.Equal
)

func testOffers(t *testing.T) {
	t.Parallel()

	query := Offers()

	if query.Query == nil {
		t.Error("expected a query, got nothing")
	}
}

func testOffersDelete(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := o.Delete(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Offers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testOffersQueryDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := Offers().DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Offers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testOffersSliceDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := OfferSlice{o}

	if rowsAff, err := slice.DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Offers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testOffersExists(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	e, err := OfferExists(ctx, tx, o.ID)
	if err != nil {
		t.Errorf("Unable to check if Offer exists: %s", err)
	}
	if !e {
		t.Errorf("Expected OfferExists to return true, but got false.")
	}
}

func testOffersFind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	offerFound, err := FindOffer(ctx, tx, o.ID)
	if err != nil {
		t.Error(err)
	}

	if offerFound == nil {
		t.Error("want a record, got nil")
	}
}

func testOffersBind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = Offers().Bind(ctx, tx, o); err != nil {
		t.Error(err)
	}
}

func testOffersOne(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if x, err := Offers().One(ctx, tx); err != nil {
		t.Error(err)
	} else if x == nil {
		t.Error("expected to get a non nil record")
	}
}

func testOffersAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	offerOne := &Offer{}
	offerTwo := &Offer{}
	if err = randomize.Struct(seed, offerOne, offerDBTypes, false, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}
	if err = randomize.Struct(seed, offerTwo, offerDBTypes, false, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = offerOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = offerTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := Offers().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 2 {
		t.Error("want 2 records, got:", len(slice))
	}
}

func testOffersCount(t *testing.T) {
	t.Parallel()

	var err error
	seed := randomize.NewSeed()
	offerOne := &Offer{}
	offerTwo := &Offer{}
	if err = randomize.Struct(seed, offerOne, offerDBTypes, false, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}
	if err = randomize.Struct(seed, offerTwo, offerDBTypes, false, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = offerOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = offerTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Offers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 2 {
		t.Error("want 2 records, got:", count)
	}
}

func offerBeforeInsertHook(ctx context.Context, e boil.ContextExecutor, o *Offer) error {
	*o = Offer{}
	return nil
}

func offerAfterInsertHook(ctx context.Context, e boil.ContextExecutor, o *Offer) error {
	*o = Offer{}
	return nil
}

func offerAfterSelectHook(ctx context.Context, e boil.ContextExecutor, o *Offer) error {
	*o = Offer{}
	return nil
}

func offerBeforeUpdateHook(ctx context.Context, e boil.ContextExecutor, o *Offer) error {
	*o = Offer{}
	return nil
}

func offerAfterUpdateHook(ctx context.Context, e boil.ContextExecutor, o *Offer) error {
	*o = Offer{}
	return nil
}

func offerBeforeDeleteHook(ctx context.Context, e boil.ContextExecutor, o *Offer) error {
	*o = Offer{}
	return nil
}

func offerAfterDeleteHook(ctx context.Context, e boil.ContextExecutor, o *Offer) error {
	*o = Offer{}
	return nil
}

func offerBeforeUpsertHook(ctx context.Context, e boil.ContextExecutor, o *Offer) error {
	*o = Offer{}
	return nil
}

func offerAfterUpsertHook(ctx context.Context, e boil.ContextExecutor, o *Offer) error {
	*o = Offer{}
	return nil
}

func testOffersHooks(t *testing.T) {
	t.Parallel()

	var err error

	ctx := context.Background()
	empty := &Offer{}
	o := &Offer{}

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, o, offerDBTypes, false); err != nil {
		t.Errorf("Unable to randomize Offer object: %s", err)
	}

	AddOfferHook(boil.BeforeInsertHook, offerBeforeInsertHook)
	if err = o.doBeforeInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeInsertHook function to empty object, but got: %#v", o)
	}
	offerBeforeInsertHooks = []OfferHook{}

	AddOfferHook(boil.AfterInsertHook, offerAfterInsertHook)
	if err = o.doAfterInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterInsertHook function to empty object, but got: %#v", o)
	}
	offerAfterInsertHooks = []OfferHook{}

	AddOfferHook(boil.AfterSelectHook, offerAfterSelectHook)
	if err = o.doAfterSelectHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterSelectHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterSelectHook function to empty object, but got: %#v", o)
	}
	offerAfterSelectHooks = []OfferHook{}

	AddOfferHook(boil.BeforeUpdateHook, offerBeforeUpdateHook)
	if err = o.doBeforeUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpdateHook function to empty object, but got: %#v", o)
	}
	offerBeforeUpdateHooks = []OfferHook{}

	AddOfferHook(boil.AfterUpdateHook, offerAfterUpdateHook)
	if err = o.doAfterUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpdateHook function to empty object, but got: %#v", o)
	}
	offerAfterUpdateHooks = []OfferHook{}

	AddOfferHook(boil.BeforeDeleteHook, offerBeforeDeleteHook)
	if err = o.doBeforeDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeDeleteHook function to empty object, but got: %#v", o)
	}
	offerBeforeDeleteHooks = []OfferHook{}

	AddOfferHook(boil.AfterDeleteHook, offerAfterDeleteHook)
	if err = o.doAfterDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterDeleteHook function to empty object, but got: %#v", o)
	}
	offerAfterDeleteHooks = []OfferHook{}

	AddOfferHook(boil.BeforeUpsertHook, offerBeforeUpsertHook)
	if err = o.doBeforeUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpsertHook function to empty object, but got: %#v", o)
	}
	offerBeforeUpsertHooks = []OfferHook{}

	AddOfferHook(boil.AfterUpsertHook, offerAfterUpsertHook)
	if err = o.doAfterUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpsertHook function to empty object, but got: %#v", o)
	}
	offerAfterUpsertHooks = []OfferHook{}
}

func testOffersInsert(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Offers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testOffersInsertWhitelist(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Whitelist(offerColumnsWithoutDefault...)); err != nil {
		t.Error(err)
	}

	count, err := Offers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testOfferToManyOrderDeals(t *testing.T) {
	var err error
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Offer
	var b, c OrderDeal

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	if err = randomize.Struct(seed, &b, orderDealDBTypes, false, orderDealColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, orderDealDBTypes, false, orderDealColumnsWithDefault...); err != nil {
		t.Fatal(err)
	}

	b.OfferID = a.ID
	c.OfferID = a.ID

	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := a.OrderDeals().All(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	bFound, cFound := false, false
	for _, v := range check {
		if v.OfferID == b.OfferID {
			bFound = true
		}
		if v.OfferID == c.OfferID {
			cFound = true
		}
	}

	if !bFound {
		t.Error("expected to find b")
	}
	if !cFound {
		t.Error("expected to find c")
	}

	slice := OfferSlice{&a}
	if err = a.L.LoadOrderDeals(ctx, tx, false, (*[]*Offer)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.OrderDeals); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	a.R.OrderDeals = nil
	if err = a.L.LoadOrderDeals(ctx, tx, true, &a, nil); err != nil {
		t.Fatal(err)
	}
	if got := len(a.R.OrderDeals); got != 2 {
		t.Error("number of eager loaded records wrong, got:", got)
	}

	if t.Failed() {
		t.Logf("%#v", check)
	}
}

func testOfferToManyAddOpOrderDeals(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Offer
	var b, c, d, e OrderDeal

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, offerDBTypes, false, strmangle.SetComplement(offerPrimaryKeyColumns, offerColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	foreigners := []*OrderDeal{&b, &c, &d, &e}
	for _, x := range foreigners {
		if err = randomize.Struct(seed, x, orderDealDBTypes, false, strmangle.SetComplement(orderDealPrimaryKeyColumns, orderDealColumnsWithoutDefault)...); err != nil {
			t.Fatal(err)
		}
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = c.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	foreignersSplitByInsertion := [][]*OrderDeal{
		{&b, &c},
		{&d, &e},
	}

	for i, x := range foreignersSplitByInsertion {
		err = a.AddOrderDeals(ctx, tx, i != 0, x...)
		if err != nil {
			t.Fatal(err)
		}

		first := x[0]
		second := x[1]

		if a.ID != first.OfferID {
			t.Error("foreign key was wrong value", a.ID, first.OfferID)
		}
		if a.ID != second.OfferID {
			t.Error("foreign key was wrong value", a.ID, second.OfferID)
		}

		if first.R.Offer != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}
		if second.R.Offer != &a {
			t.Error("relationship was not added properly to the foreign slice")
		}

		if a.R.OrderDeals[i*2] != first {
			t.Error("relationship struct slice not set to correct value")
		}
		if a.R.OrderDeals[i*2+1] != second {
			t.Error("relationship struct slice not set to correct value")
		}

		count, err := a.OrderDeals().Count(ctx, tx)
		if err != nil {
			t.Fatal(err)
		}
		if want := int64((i + 1) * 2); count != want {
			t.Error("want", want, "got", count)
		}
	}
}
func testOfferToOneDriverUsingDriver(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local Offer
	var foreign Driver

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, offerDBTypes, false, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, driverDBTypes, false, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.DriverID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Driver().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := OfferSlice{&local}
	if err = local.L.LoadDriver(ctx, tx, false, (*[]*Offer)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Driver == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Driver = nil
	if err = local.L.LoadDriver(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Driver == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testOfferToOneOrderUsingOrder(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local Offer
	var foreign Order

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, offerDBTypes, false, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, orderDBTypes, false, orderColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Order struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.OrderID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Order().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := OfferSlice{&local}
	if err = local.L.LoadOrder(ctx, tx, false, (*[]*Offer)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Order == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Order = nil
	if err = local.L.LoadOrder(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Order == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testOfferToOneSetOpDriverUsingDriver(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Offer
	var b, c Driver

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, offerDBTypes, false, strmangle.SetComplement(offerPrimaryKeyColumns, offerColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Driver{&b, &c} {
		err = a.SetDriver(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Driver != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.Offers[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.DriverID != x.ID {
			t.Error("foreign key was wrong value", a.DriverID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.DriverID))
		reflect.Indirect(reflect.ValueOf(&a.DriverID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if a.DriverID != x.ID {
			t.Error("foreign key was wrong value", a.DriverID, x.ID)
		}
	}
}
func testOfferToOneSetOpOrderUsingOrder(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Offer
	var b, c Order

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, offerDBTypes, false, strmangle.SetComplement(offerPrimaryKeyColumns, offerColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, orderDBTypes, false, strmangle.SetComplement(orderPrimaryKeyColumns, orderColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, orderDBTypes, false, strmangle.SetComplement(orderPrimaryKeyColumns, orderColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Order{&b, &c} {
		err = a.SetOrder(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Order != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.Offers[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.OrderID != x.ID {
			t.Error("foreign key was wrong value", a.OrderID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.OrderID))
		reflect.Indirect(reflect.ValueOf(&a.OrderID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if a.OrderID != x.ID {
			t.Error("foreign key was wrong value", a.OrderID, x.ID)
		}
	}
}

func testOffersReload(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = o.Reload(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testOffersReloadAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := OfferSlice{o}

	if err = slice.ReloadAll(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testOffersSelect(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := Offers().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 1 {
		t.Error("want one record, got:", len(slice))
	}
}

var (
	offerDBTypes = map[string]string{`ID`: `bigint`, `OrderID`: `bigint`, `DriverID`: `bigint`, `Price`: `bigint`, `DTCreated`: `timestamp without time zone`, `DTUpdated`: `timestamp without time zone`}
	_            = bytes.MinRead
)

func testOffersUpdate(t *testing.T) {
	t.Parallel()

	if 0 == len(offerPrimaryKeyColumns) {
		t.Skip("Skipping table with no primary key columns")
	}
	if len(offerColumns) == len(offerPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Offers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, offerDBTypes, true, offerPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	if rowsAff, err := o.Update(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only affect one row but affected", rowsAff)
	}
}

func testOffersSliceUpdateAll(t *testing.T) {
	t.Parallel()

	if len(offerColumns) == len(offerPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &Offer{}
	if err = randomize.Struct(seed, o, offerDBTypes, true, offerColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Offers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, offerDBTypes, true, offerPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	// Remove Primary keys and unique columns from what we plan to update
	var fields []string
	if strmangle.StringSliceMatch(offerColumns, offerPrimaryKeyColumns) {
		fields = offerColumns
	} else {
		fields = strmangle.SetComplement(
			offerColumns,
			offerPrimaryKeyColumns,
		)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	typ := reflect.TypeOf(o).Elem()
	n := typ.NumField()

	updateMap := M{}
	for _, col := range fields {
		for i := 0; i < n; i++ {
			f := typ.Field(i)
			if f.Tag.Get("boil") == col {
				updateMap[col] = value.Field(i).Interface()
			}
		}
	}

	slice := OfferSlice{o}
	if rowsAff, err := slice.UpdateAll(ctx, tx, updateMap); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("wanted one record updated but got", rowsAff)
	}
}

func testOffersUpsert(t *testing.T) {
	t.Parallel()

	if len(offerColumns) == len(offerPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	// Attempt the INSERT side of an UPSERT
	o := Offer{}
	if err = randomize.Struct(seed, &o, offerDBTypes, true); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Upsert(ctx, tx, false, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert Offer: %s", err)
	}

	count, err := Offers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}

	// Attempt the UPDATE side of an UPSERT
	if err = randomize.Struct(seed, &o, offerDBTypes, false, offerPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Offer struct: %s", err)
	}

	if err = o.Upsert(ctx, tx, true, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert Offer: %s", err)
	}

	count, err = Offers().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}
}
